#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ArenaFreeRankingCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ArenaFreeRankingCFG> Fish_ArenaFreeRankingCFG::msSingleton(nullptr);

int Fish_ArenaFreeRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArenaFreeRankingCFGData* Fish_ArenaFreeRankingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ArenaFreeRankingCFGData>& Fish_ArenaFreeRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArenaFreeRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ArenaFreeRankingCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArenaFreeRankingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		data.mRewardItem = element->IntAttribute("RewardItem");
		data.mRewardCount = element->IntAttribute("RewardCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ArenaFreeRankingCFG::Load()
{
	Load("../Config/Fish_ArenaFreeRankingCFG.xml");
}

Fish_ArenaFreeRankingCFG* Fish_ArenaFreeRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArenaFreeRankingCFG());
	}
	return msSingleton.get();
}
